{ config, pkgs, lib, ... }:
{
  # Bootloader.
  boot.loader.systemd-boot.enable = true;
  boot.loader.efi.canTouchEfiVariables = true;

  boot.binfmt.emulatedSystems = [
    "riscv64-linux"
  ];

  #boot.kernelPackages = pkgs.linuxPackages_latest;
  #hardware.nvidia.package = config.boot.kernelPackages.nvidiaPackages.latest;
  #hardware.nvidia.modesetting.enable = false; # makes atom behave, but mpv refuses to start

  # The open source driver does not support Pascal GPUs (1080)
  # https://github.com/NixOS/nixos-hardware/blob/master/common/gpu/nvidia/pascal/default.nix
  hardware.nvidia.open = false;

  # PRIME: (lspci)
  #hardware.nvidia.prime.intelBusId  = "PCI:0:02:0";
  #hardware.nvidia.prime.nvidiaBusId = "PCI:1:00:0";

  imports = [
    ./hardware-configuration.nix
    ../../../profiles/sshd.nix
    #../../../profiles/no-suspend.nix
    #../../../profiles/oci/podman.nix
    ../../../profiles/oci/docker.nix

    ../../../users/pbsds
    ../../../users/daniel
    ../../../users/eirikwit
    ../../../users/h7x4
    ../../../users/adrlau

    ../../../profiles/shell.nix

    ../../../profiles/domeneshop-dyndns.nix
    ../../../profiles/known-hosts.nix
  ];
  services.domeneshop-updater.targets = [ config.networking.fqdn ];

  # Networking
  networking.networkmanager.enable = true;

  # TODO: remove? Move?
  programs.dconf.enable = true;
}
