{ config, lib, pkgs, ... }:
{

  # nvd: https://discourse.nixos.org/t/nvd-simple-nix-nixos-version-diff-tool/12397
  # module from https://github.com/luishfonseca/dotfiles/blob/ab7625ec406b48493eda701911ad1cd017ce5bc1/modules/upgrade-diff.nix
  # gated on formatAttr which is set by nixos-generators
  system.activationScripts.diff = lib.mkIf ((config.formatAttr or null) == null) {
    supportsDryActivation = true;
    text = ''
      ${pkgs.nvd}/bin/nvd --nix-bin-dir=${pkgs.nix}/bin diff /run/current-system "$systemConfig"
    '';
  };

}
